﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Excel;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace ExcelExporterOnSeparateThread
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public void ThreadTask(object data)
        {
            XamDataGrid myGrid = new XamDataGrid();
            myGrid.DataSource = data as ObservableCollection<string>;
            myGrid.BeginInit();
            myGrid.EndInit();
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.Export(myGrid as XamDataGrid, "xamDataPresenter1.xlsx", WorkbookFormat.Excel2007);
        }

        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<string> data = new ObservableCollection<string>();
            data.Add("Item");
            data.Add("Item"); data.Add("Item"); data.Add("Item"); data.Add("Item"); data.Add("Item");
            xamDataGrid1.DataSource = data;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Thread myThread = new Thread(this.ThreadTask);
            myThread.SetApartmentState(ApartmentState.STA); //Set the thread to STA
            myThread.Start(xamDataGrid1.DataSource);
            myThread.Join(); //Wait for the thread to end
            Process.Start("xamDataPresenter1.xlsx");
        }
    }
}
